/***************************************************************************
Name: JSView
Version: 1.1.7
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://scorpiondb.com/firefox/extensions/jsview/
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/





var jsvOptions = {

	getMozillaPath: function() {
		var tmp;
		var url = Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService).
		newURI('chrome://jsview/content/', "UTF-8", null);

		var path = Components.classes["@mozilla.org/chrome/chrome-registry;1"].
		getService(Components.interfaces.nsIChromeRegistry).
		convertChromeURL(url).spec;

		if (path.substr(0,4)=='jar:') path = path.substr(4);
		if ((tmp = path.search(/chrome\/jsview.jar\!/))!=-1) path = path.substr(0,tmp);
		return path;
	},

	defaultTmpFolder: function(y) {
		var path = this.getMozillaPath();
		path += 'temp/';
		var dir = this.urlToPath(path);

		var prefs = this.getPrefs();
		prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, dir);

		var tmploc = document.getElementById('templocation');
		tmploc.value = dir.path;
		tmploc.removeAttribute('style');
		if (y) alert(this.getSt('jsview.Success'));
	},

	urlToPath: function(url) {
		return Components.classes["@mozilla.org/network/protocol;1?name=file"].
		createInstance(Components.interfaces.nsIFileProtocolHandler).
		getFileFromURLSpec(url);
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");
	},

	getSt: function(name) {
		var strbdl = document.getElementById("jsview-bundle");
		var msg = strbdl.getString(name);
		return msg;
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	framePrefHelp: function() {
		alert(this.getSt('jsview.FrPrfHlp'));
	},

	tempfileWarning: function() {
		alert(this.getSt('jsview.TmpFiWng'));
	},

	clickHelp: function() {
		alert(this.getSt('jsview.ClickHelp'));
	},

	behavior: function() {
		var one = this.getSt('jsview.OpenNewWin');
		var two = this.getSt('jsview.OpenBlur');
		var three = this.getSt('jsview.OpenFocus');
		var four = this.getSt('jsview.External');
		var attrib = document.getElementById('chooseBehavior');
		var current = attrib.value;

		if (current == one) {
			attrib.value = two;
		} else if (current == two) {
			attrib.value = three;
		} else if (current == three) {
			attrib.value = four;
		} else if (current == four || current == '') {
			attrib.value = one;
		} else {
			attrib.value = one;
		}
	},

	onDialogLoad: function() {

		moveTo((screen.width-300)/2,(screen.height-262)/2);

		var prefs = this.getPrefs();

		document.getElementById('disableContext').checked = prefs.getBoolPref('disableContext');
		document.getElementById('disableStatus').checked = prefs.getBoolPref('disableStatus');
		document.getElementById('clearTemp').checked = prefs.getBoolPref('clearTemp');
		document.getElementById('disableToolsOptions').checked = prefs.getBoolPref('disableToolsOptions');
		document.getElementById('framePref').checked = prefs.getBoolPref('framePref');
		document.getElementById('activateOnclick').checked = prefs.getBoolPref('activateOnclick');

		var textone = document.getElementById('applocation');
		if (prefs.getCharPref('extapp')) {
			textone.value = prefs.getComplexValue('extapp', Components.interfaces.nsILocalFile).path;
		} else {
			textone.value = this.getSt('jsview.SelectApp');
			textone.style.setProperty('color','red',null);
			textone.style.setProperty('font-weight','900',null);
			textone.style.setProperty('background','yellow',null);
		}

		var texttwo = document.getElementById('templocation');
		if (prefs.getCharPref('temploc')) {
			texttwo.value = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile).path;
		} else {
			this.defaultTmpFolder();
		}

		var bhvr = document.getElementById('chooseBehavior');
		var bhvrVal = prefs.getCharPref('chooseBehavior');
		if (bhvrVal=='chrome://jsview/locale/jsview.properties') {
			bhvr.value = this.getSt('jsview.OpenNewWin');
		} else {
			bhvr.value = bhvrVal;
		}
	},

	onDialogAccept: function() {
		var win = this.getMainWin();
		var prefs = this.getPrefs();

		var toolsmenudiff,contextdiff,statusdiff;

		var checkone = document.getElementById("disableContext");
		(checkone.checked != prefs.getBoolPref("disableContext")) ? contextdiff = "yes" : contextdiff = "no";
		prefs.setBoolPref("disableContext", checkone.checked);

		var checktwo = document.getElementById("disableStatus");
		(checktwo.checked != prefs.getBoolPref("disableStatus")) ? statusdiff = "yes" : statusdiff = "no";
		prefs.setBoolPref("disableStatus", checktwo.checked);

		var checkfour = document.getElementById("clearTemp");
		prefs.setBoolPref("clearTemp", checkfour.checked);

		var checkfive = document.getElementById("disableToolsOptions");
		(checkfive.checked != prefs.getBoolPref("disableToolsOptions")) ? toolsmenudiff = "yes" : toolsmenudiff = "no";
		prefs.setBoolPref("disableToolsOptions", checkfive.checked);

		var checkeight = document.getElementById("framePref");
		prefs.setBoolPref("framePref", checkeight.checked);

		var click = document.getElementById('activateOnclick');
		if (click.checked==true) {
			win.document.getElementById('jsview-status').setAttribute('onclick','jsview.jsviewStatus();');
		} else {
			win.document.getElementById('jsview-status').removeAttribute('onclick');
		}
		prefs.setBoolPref('activateOnclick',click.checked);

		var txtone = document.getElementById('chooseBehavior');
		if (txtone.value==this.getSt('jsview.OpenNewWin')) {
			prefs.setCharPref('chooseBehavior','chrome://jsview/locale/jsview.properties');
		} else {
			prefs.setCharPref("chooseBehavior", txtone.value);
		}

		var contextmenu = win.document.getElementById('contentAreaContextMenu');
		var jscontext = win.document.getElementById('jsview-context-popup');
		var csscontext = win.document.getElementById('cssview-context-popup');
		var jscontextmenu = win.document.getElementById('jsview-context-menu');
		var csscontextmenu = win.document.getElementById('cssview-context-menu');
		if (contextdiff == 'yes') {
			if (!checkone.checked) {
				contextmenu.addEventListener("popupshowing", win.jsviewListen.CL, false);
				jscontext.addEventListener("popupshowing", win.jsviewListen.JSCL, false);
				csscontext.addEventListener("popupshowing", win.jsviewListen.CSSCL, false);
			} else {
				contextmenu.removeEventListener("popupshowing", win.jsviewListen.CL, false);
				jscontext.removeEventListener("popupshowing", win.jsviewListen.JSCL, false);
				csscontext.removeEventListener("popupshowing", win.jsviewListen.CSSCL, false);
				jscontextmenu.setAttribute('hidden',true);
				csscontextmenu.setAttribute('hidden',true);
			}
		}


		var status = win.document.getElementById('jsview-status');
		var statuspopup = win.document.getElementById('jsview-status-popup');
		if (statusdiff == "yes") {
			if (!checktwo.checked) {
				statuspopup.addEventListener("popupshowing", win.jsviewListen.SL, false);
				status.setAttribute('hidden',false);
			} else {
				statuspopup.removeEventListener("popupshowing", win.jsviewListen.SL, false);
				status.setAttribute('hidden',true);
			}
		}

		var toolsmenu = win.document.getElementById('jsview-options');
		if (toolsmenudiff == "yes") {
			if (!checkfive.checked) {
				toolsmenu.setAttribute('hidden',false);
			} else {
				toolsmenu.setAttribute('hidden',true);
			}
		}
	},

	chooseProgram: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
        		createInstance(nsIFilePicker);
		fp.init(window, this.getSt('jsview.SelectExt'), nsIFilePicker.modeOpen);
		fp.appendFilter(this.getSt('jsview.Programs'),"*.exe");
		fp.appendFilter(this.getSt('jsview.AllFiles'),"*.*");
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = this.getPrefs();
			prefs.setComplexValue('extapp', Components.interfaces.nsILocalFile, fp.file);
			document.getElementById('applocation').value = fp.file.path;
			document.getElementById('applocation').removeAttribute('style');
		}
	},

	chooseTemp: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
			createInstance(nsIFilePicker);
		fp.init(window, this.getSt('jsview.SelectTmp'), nsIFilePicker.modeGetFolder);
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = this.getPrefs();
			prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, fp.file);
			document.getElementById('templocation').value = fp.file.path;
			document.getElementById('templocation').removeAttribute('style');
		}
	}
};