/***************************************************************************
Name: JSView
Version: 1.1.7
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://scorpiondb.com/firefox/extensions/jsview/
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



window.addEventListener("load", jsviewLoad, false);

function jsviewLoad() {
	gBrowser.addProgressListener(jsviewProgress);
	jsview.jsviewInit();
}

window.addEventListener("unload", jsviewUnload, false);

function jsviewUnload() {
	jsview.removeTemp();
}

var jsviewProgress = {

	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
		aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		aIID.equals(Components.interfaces.nsISupports))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},

	onLinkIconAvailable: function(a) { },
	onLocationChange: function(a,b,c) {
		if ((a && a.isLoadingDocument==false) || !a) {
			jsview.jsviewOnload();
		}
	},

	onProgressChange: function(a,b,c,d,e,f) { },
	onSecurityChange: function(a,b,c) { },
	onStateChange: function(a,b,c,d) {
		if ((a && a.isLoadingDocument==false) || !a) {
			jsview.jsviewOnload();
		}
	},
	onStatusChange: function(a,b,c,d) { }
};

var jsview = {

	getMozillaPath: function() {
		var tmp;
		var url = Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService).
		newURI('chrome://jsview/content/', "UTF-8", null);

		var path = Components.classes["@mozilla.org/chrome/chrome-registry;1"].
		getService(Components.interfaces.nsIChromeRegistry).
		convertChromeURL(url).spec;

		if (path.substr(0,4)=='jar:') path = path.substr(4);
		if ((tmp = path.search(/chrome\/jsview.jar\!/))!=-1) path = path.substr(0,tmp);
		return path;
	},

	defaultTmpFolder: function(y) {
		var path = this.getMozillaPath();
		path += 'temp/';
		var dir = this.urlToPath(path);

		var prefs = this.getPrefs();
		prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, dir);
	},

	urlToPath: function(url) {
		return Components.classes["@mozilla.org/network/protocol;1?name=file"].
		createInstance(Components.interfaces.nsIFileProtocolHandler).
		getFileFromURLSpec(url);
	},

	objectRef: function() {
		var url = window.content.document.location.href;
		var arg1 = 'top.frames[1]';
		window.openDialog('chrome://jsview/content/jsviewObjRef.xul','ObjRef','chrome,resizable=yes',arg1,url);
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	getSt: function(name) {
		var strbdl = document.getElementById("jsview-bundle");
		var msg = strbdl.getString(name);
		return msg;
	},

	viewSourceOfURL: function(url) {
		if ('ViewSourceOfURL' in window &&
		     typeof(window.ViewSourceOfURL)=='function') {
			ViewSourceOfURL(url);
		} else if ('BrowserViewSourceOfURL' in window &&
			    typeof(window.BrowserViewSourceOfURL)=='function') {
				BrowserViewSourceOfURL(url);
		} else if ('gViewSourceUtils' in window &&
			   'openInInternalViewer' in gViewSourceUtils &&
			    typeof(gViewSourceUtils.openInInternalViewer)=='function') {
				gViewSourceUtils.openInInternalViewer(url);
		} else {
			openDialog("chrome://global/content/viewSource.xul",
			"_blank",
			"scrollbars,resizable,chrome,dialog=no",
			url, null, null);
		}
	},

	jsviewMain: function(arg) {
		var prefs = this.getPrefs();
		var win = this.getMainWin();

		var ext,param;
		var behavior = prefs.getCharPref('chooseBehavior');
		var one = this.getSt('jsview.OpenBlur');
		var two = this.getSt('jsview.OpenFocus');
		var three = this.getSt('jsview.External');

		if (behavior==one) {
			ext = arg.substr(-3);
			param = arg.substr(-7);
			if (ext!='css' && ext!='.js' && param!='?jsview') arg = 'view-source:'+arg;
			win.getBrowser().addTab(arg+'?jsview');
		} else if (behavior==two) {
			ext = arg.substr(-3);
			param = arg.substr(-7);
			if (ext!='css' && ext!='.js' && param!='?jsview') arg = 'view-source:'+arg;
			var newTab = win.getBrowser().addTab(arg+'?jsview');
			win.getBrowser().selectedTab = newTab;
		} else if (behavior==three) {
			this.startProcess(arg);
		} else {
			this.viewSourceOfURL(arg);
		}
	},

	jsviewOpenAllJS: function() {
		var js = this.isJSExternal();
		var i;
		for (i=0; i<js.length; ++i) {
			setTimeout("jsview.jsviewMain('"+js[i]+"')",i*500);
		}
	},

	jsviewOpenAllCSS: function() {
		var css = this.isCSSExternal();
		var i;
		for (i=0; i<css.length; ++i) {
			setTimeout("jsview.jsviewMain('"+css[i]+"')",i*500);
		}
	},

	jsviewInit: function() {
		var prefs = this.getPrefs();

		//create temp folder location if not found
		if (!prefs.getCharPref('temploc')) {
			this.defaultTmpFolder();
		}

		//add onclick event to popup menu for users who cannot use popupshowing
		var aoc = prefs.getBoolPref('activateOnclick');
		if (aoc==true) {
			document.getElementById('jsview-status').setAttribute('onclick','jsview.jsviewStatus();');
		}

		var toolsmenupref = prefs.getBoolPref('disableToolsOptions');
		var jsviewtoolsoptions = document.getElementById('jsview-options');

		var contextpref = prefs.getBoolPref("disableContext");
		var contextmenu = document.getElementById("contentAreaContextMenu");
		var jscontext = document.getElementById('jsview-context-popup');
		var csscontext = document.getElementById('cssview-context-popup');

		var toolbar = document.getElementById('menu_viewPopup') ||
			      document.getElementById('menu_View_Popup');
		var jstoolbar = document.getElementById("jsview-toolbar-popup");
		var csstoolbar = document.getElementById("cssview-toolbar-popup");

		var button = document.getElementById('jsview-button');
		var buttonpopup = document.getElementById('jsview-button-popup');

		var statuspref = prefs.getBoolPref("disableStatus");
		var status = document.getElementById('jsview-status');
		var statuspopup = document.getElementById('jsview-status-popup');

		if (contextpref==false && contextmenu && jscontext && csscontext) {
			contextmenu.addEventListener("popupshowing", jsviewListen.CL, false);
			jscontext.addEventListener("popupshowing", jsviewListen.JSCL, false);
			csscontext.addEventListener("popupshowing", jsviewListen.CSSCL, false);
		} else {
			document.getElementById('jsview-context-menu').setAttribute('hidden',true);
			document.getElementById('cssview-context-menu').setAttribute('hidden',true);
		}

		if (contextmenu) {
			contextmenu.addEventListener("popupshowing", jsviewListen.EECL, false);
		}

		if (toolbar && jstoolbar && csstoolbar) {
			toolbar.addEventListener("popupshowing", jsviewListen.TL, false);
			jstoolbar.addEventListener("popupshowing", jsviewListen.JSTL, false);
			csstoolbar.addEventListener("popupshowing", jsviewListen.CSSTL,false);
		} else {
			document.getElementById('jsview-toolbar-menu').setAttribute('hidden',true);
			document.getElementById('cssview-toolbar-menu').setAttribute('hidden',true);
		}

		if (buttonpopup) {
			buttonpopup.addEventListener("popupshowing", jsviewListen.BL, false);
		}

		if (statuspref==false && statuspopup) {
			statuspopup.addEventListener("popupshowing", jsviewListen.SL, false);
		} else if (status) {
			status.setAttribute('hidden',true);
		}

		if (toolsmenupref==false && jsviewtoolsoptions) {
			jsviewtoolsoptions.setAttribute('hidden',false);
		} else {
			jsviewtoolsoptions.setAttribute('hidden',true);
		}
	},

	extEditorContext: function() {
		var loc = window.content.document.location.href.substr(-7);
		if (loc=='?jsview') {
			document.getElementById('jsview-editor').setAttribute('hidden',false);
		} else {
			document.getElementById('jsview-editor').setAttribute('hidden',true);
		}
	},

	jsviewContext: function() {
		var loc = window.content.document.location.href.substr(-7);
		if (loc=='?jsview') {
			document.getElementById('jsview-editor').setAttribute('hidden',false);
		} else {
			document.getElementById('jsview-editor').setAttribute('hidden',true);
		}

		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jscontext = document.getElementById('jsview-context-menu');
		var csscontext = document.getElementById('cssview-context-menu');

		if (js.length > 0 && !gContextMenu.onLink) {
			jscontext.setAttribute('hidden',false);
			jscontext.setAttribute('label',this.getSt('jsview.ViewExtJs')+" (" +js.length+ ")");
		} else {
			jscontext.setAttribute('hidden',true);
		}

		if (css.length > 0 && !gContextMenu.onLink) {
			csscontext.setAttribute('hidden',false);
			csscontext.setAttribute('label',this.getSt('jsview.ViewExtCss')+" (" +css.length+ ")");
		} else {
			csscontext.setAttribute('hidden',true);
		}
	},

	jsviewJSContext: function() {
		var i,temp,name;
		var js = this.isJSExternal();
		var jscontext = document.getElementById('jsview-context-popup');

		while (jscontext.firstChild) {
			jscontext.removeChild(jscontext.firstChild);
		}

		if (js.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','context-viewalljs');
			temp.setAttribute('label',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jscontext.appendChild(temp);

			for (i=0; i<js.length; ++i) {
				name = js[i].substr(js[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+js[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
				temp.setAttribute('class','menuitem-iconic');
				jscontext.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-context-item-nf');
			temp.setAttribute('label',this.getSt('jsview.JsNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.JsNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jscontext.appendChild(temp);
		}
	},

	jsviewCSSContext: function() {
		var i,name,temp;
		var css = this.isCSSExternal();
		var csscontext = document.getElementById('cssview-context-popup');

		while (csscontext.firstChild) {
			csscontext.removeChild(csscontext.firstChild);
		}

		if (css.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','context-viewallcss');
			temp.setAttribute('label',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			csscontext.appendChild(temp);

			for (i=0; i<css.length; ++i) {
				name = css[i].substr(css[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+css[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
				temp.setAttribute('class','menuitem-iconic');
				csscontext.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-context-item-nf');
			temp.setAttribute('label',this.getSt('jsview.CssNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.CssNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			csscontext.appendChild(temp);
		}
	},

	jsviewToolbar: function() {
		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jstoolbar = document.getElementById('jsview-toolbar-menu');
		var csstoolbar = document.getElementById('cssview-toolbar-menu');

		if (js.length > 0) {
			jstoolbar.setAttribute('hidden',false);
			jstoolbar.setAttribute('label',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
		} else {
			jstoolbar.setAttribute('hidden',true);
		}

		if (css.length > 0) {
			csstoolbar.setAttribute('hidden',false);
			csstoolbar.setAttribute('label',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
		} else {
			csstoolbar.setAttribute('hidden',true);
		}
	},

	jsviewJSToolbar: function() {
		var i,name,temp;
		var js = this.isJSExternal();
		var jstools = document.getElementById('jsview-toolbar-popup');

		while (jstools.firstChild) {
			jstools.removeChild(jstools.firstChild);
		}

		if (js.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','toolbar-viewalljs');
			temp.setAttribute('label',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jstools.appendChild(temp);

			for (i=0; i<js.length; ++i) {
				name = js[i].substr(js[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('statustext',js[i]);
				temp.setAttribute('class','menuitem-iconic');
				jstools.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-toolbar-item-nf');
			temp.setAttribute('label',this.getSt('jsview.JsNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.JsNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jstools.appendChild(temp);
		}
	},

	jsviewCSSToolbar: function() {
		var i,name,temp;
		var css = this.isCSSExternal();
		var csstools = document.getElementById('cssview-toolbar-popup');

		while (csstools.firstChild) {
			csstools.removeChild(csstools.firstChild);
		}

		if (css.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','toolbar-viewallcss');
			temp.setAttribute('label',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			csstools.appendChild(temp);

			for (i=0; i<css.length; ++i) {
				name = css[i].substr(css[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('statustext',css[i]);
				temp.setAttribute('class','menuitem-iconic');
				csstools.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-toolbar-item-nf');
			temp.setAttribute('label',this.getSt('jsview.CssNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.CssNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			csstools.appendChild(temp);
		}
	},

	jsviewButton: function() {
		var i,name,temp;
		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jsbutton = document.getElementById('jsview-button-popup');

		while (jsbutton.firstChild) {
			jsbutton.removeChild(jsbutton.firstChild);
		}

		if (js.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','button-viewalljs');
			temp.setAttribute('label',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jsbutton.appendChild(temp);

			for (i=0; i<js.length; ++i) {
				name = js[i].substr(js[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+js[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
				temp.setAttribute('class','menuitem-iconic');
				jsbutton.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-button-item-nf');
			temp.setAttribute('label',this.getSt('jsview.JsNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.JsNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jsbutton.appendChild(temp);
		}

		temp = document.createElement('menuseparator');
		jsbutton.appendChild(temp);

		if (css.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','button-viewallcss');
			temp.setAttribute('label',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jsbutton.appendChild(temp);

			for (i=0; i<css.length; ++i) {
				name = css[i].substr(css[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+css[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
				temp.setAttribute('class','menuitem-iconic');
				jsbutton.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-button-item-nf');
			temp.setAttribute('label',this.getSt('jsview.CssNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.CssNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jsbutton.appendChild(temp);
		}
	},

	jsviewStatus: function() {
		var i,name,temp;
		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jsstatus = document.getElementById('jsview-status-popup');

		while (jsstatus.firstChild) {
			jsstatus.removeChild(jsstatus.firstChild);
		}

		if (js.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','status-viewalljs');
			temp.setAttribute('label',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllJS()");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jsstatus.appendChild(temp);

			for (i=0; i<js.length; ++i) {
				name = js[i].substr(js[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+js[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
				temp.setAttribute('class','menuitem-iconic');
				jsstatus.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-status-item-nf');
			temp.setAttribute('label',this.getSt('jsview.JsNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.JsNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jsstatus.appendChild(temp);
		}

		temp = document.createElement('menuseparator');
		jsstatus.appendChild(temp);

		if (css.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','status-viewallcss');
			temp.setAttribute('label',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('oncommand',"jsview.jsviewOpenAllCSS()");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jsstatus.appendChild(temp);

			for (i=0; i<css.length; ++i) {
				name = css[i].substr(css[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsview.jsviewMain('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+css[i]+"';");
				temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
				temp.setAttribute('class','menuitem-iconic');
				jsstatus.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-status-item-nf');
			temp.setAttribute('label',this.getSt('jsview.CssNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.CssNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jsstatus.appendChild(temp);
		}
	},

	jsviewOnload: function() {
		var js,css;
		var button = document.getElementById('jsview-button');
		var status = document.getElementById('jsview-status');

		try { js = this.isJSExternal(); } catch(e) { js=""; }
		try { css = this.isCSSExternal(); } catch(e) { css=""; }

		if (button) {
			if (js.length > 0 && css.length < 1) {
				button.setAttribute('image',"chrome://jsview/skin/js.gif");
				button.setAttribute('tooltiptext',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
			} else if (css.length > 0 && js.length < 1) {
				button.setAttribute('image',"chrome://jsview/skin/css.gif");
				button.setAttribute('tooltiptext',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
			} else if (js.length > 0 && css.length > 0) {
				button.setAttribute('image',"chrome://jsview/skin/both.gif");
				button.setAttribute('tooltiptext',"JS (" +js.length+ ")  CSS (" +css.length+ ")");
			} else {
				button.setAttribute('image',"chrome://jsview/skin/none.gif");
				button.setAttribute('tooltiptext',this.getSt('jsview.NF'));
			}
		}

		if (status && status.hidden==false) {
			if (js.length > 0 && css.length < 1) {
				status.setAttribute('src',"chrome://jsview/skin/js.gif");
				status.setAttribute('tooltiptext',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
			} else if (css.length > 0 && js.length < 1) {
				status.setAttribute('src',"chrome://jsview/skin/css.gif");
				status.setAttribute('tooltiptext',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
			} else if (js.length > 0 && css.length > 0) {
				status.setAttribute('src',"chrome://jsview/skin/both.gif");
				status.setAttribute('tooltiptext',"JS (" +js.length+ ")  CSS (" +css.length+ ")");
			} else {
				status.setAttribute('src',"chrome://jsview/skin/none.gif");
				status.setAttribute('tooltiptext',this.getSt('jsview.NF'));
			}
		}
	},

	isJSExternal: function() {
		var loc = window.content.document.location.href;
		var scriptarray = [];
		var j,i,m,ext;

		var allscripts = window.content.document.getElementsByTagName('script');
		if (allscripts[0]) {
			for (i=0; i<allscripts.length; ++i) {
				if (allscripts[i].src && allscripts[i].src!=loc) {
					ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
					if (ext!='.cgi') scriptarray.push(allscripts[i].src);
				}
			}
		}

		var pages = window.content.parent.frames;
		if (pages.length > 0) {
			for (m=0; m<pages.length; ++m) {
				var allscripts = pages[m].document.getElementsByTagName('script');
				if (allscripts[0]) {
					for (i=0; i<allscripts.length; ++i) {
						if (allscripts[i].src && allscripts[i].src!=loc) {
							ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
							if (ext!='.cgi') scriptarray.push(allscripts[i].src);
						}
					}
				}
			}
		}

		//check for duplicate entries and remove them
		scriptarray.sort();
		for (i=0; i<scriptarray.length-1; ++i) {
			while (scriptarray[i]==scriptarray[i+1]) {
				scriptarray.splice(i,1);
			}
		}

		return scriptarray;
	},

	isCSSExternal: function() {
		var loc = window.content.document.location.href;
		var cssarray = [];
		var j,i,m;

		var sheets = window.content.document.styleSheets;
		if (sheets.length > 0) {
			for (i=0; i<sheets.length; ++i) {
				if (sheets[i].href && sheets[i].href!=loc) {
					cssarray.push(sheets[i].href);
				}
				cssarray = cssarray.concat(this.importedCSS(sheets[i]));
			}
		}

		var pages = window.content.parent.frames;
		if (pages.length > 0) {
			for (m=0; m<pages.length; ++m) {
				var sheets = pages[m].document.styleSheets;
				if (sheets.length > 0) {
					for (i=0; i<sheets.length; ++i) {
						if (sheets[i].href && sheets[i].href!=loc) {
							cssarray.push(sheets[i].href);
						}
						cssarray = cssarray.concat(this.importedCSS(sheets[i]));
					}
				}
			}
		}

		//check for duplicate entries and remove them
		cssarray.sort();
		for (i=0; i<cssarray.length-1; ++i) {
			while (cssarray[i]==cssarray[i+1]) {
				cssarray.splice(i,1);
			}
		}

		return cssarray;
	},

	importedCSS: function(css) {
		var j;
		var cssarray = [];
		var rules = css.cssRules;
		for (j=0; j<rules.length; ++j) {
			if (rules[j].type==3) {
				cssarray.push(rules[j].styleSheet.href);
				cssarray = cssarray.concat(this.importedCSS(rules[j].styleSheet));
			} else { break; }
		}
		return cssarray;
	},

	startProcess: function(url) {
		var obj_Program,filename;
		var prefs = this.getPrefs();

		if (!prefs.getCharPref('extapp')) {
			obj_Program = this.chooseProgram();
			if (obj_Program==false) { return false; }
		} else {
			obj_Program = prefs.getComplexValue('extapp', Components.interfaces.nsILocalFile);
		}

		//initialize process
		try {
			var obj_Process = Components.classes["@mozilla.org/process/util;1"].
				createInstance(Components.interfaces.nsIProcess);
			obj_Process.init(obj_Program);
		} catch(e) {
			alert(this.getSt('jsview.EditorNF'));
			return false;
		}

		//remove jsview parameter
		if (url.substr(-7)=='?jsview') {
			url = url.substr(0,url.search(/\?jsview/));
		}

		//var os = navigator.userAgent.search(/Mac/);
		var prot = url.substr(0,4);

		if (prot=='file') {
			//if url is local and os is not mac
			var file = this.urlToPath(url);
			filename = [file.path];
		} else {
			//create temporary file
			var request=new XMLHttpRequest();
			request.open("GET",url,false);
			request.send(null);
			filename = [this.writeFile(request.responseText,url)];
		}

		if (filename[0]==false) { return false; }

		//open external editor
		obj_Process.run(false, filename, 1);
		return false;
	},

	writeFile: function(sFileContent,name) {
		var obj_Temp;
		var prefs = this.getPrefs();

		if (!prefs.getCharPref('temploc')) {
			//obj_Temp = this.chooseTemp();
			//if (obj_Temp==false) { return false; }
			//set temp location automatically
			this.defaultTmpFolder();
		}

		obj_Temp = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile);

		var filename = name.substr(name.lastIndexOf('/'));
		filename = filename.replace(/[~!@#$%^&*()_+|`\-=\\\[\];',\/{}:"<>? ]/g,"");
		if (filename.length<1) filename = 'index.htm';
		obj_Temp.append(filename);

		try {
			var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
				createInstance(Components.interfaces.nsIFileOutputStream);
			strm.QueryInterface(Components.interfaces.nsIOutputStream);
			strm.QueryInterface(Components.interfaces.nsISeekableStream);
			strm.init(obj_Temp, 0x04 | 0x08, 420, 0);
			strm.write(sFileContent, sFileContent.length);
			strm.flush();
			strm.close();
		} catch(e) {
			alert('The temporary directory cannot be found.\nPlease double check the path and try again.');
			return false;
		}
		return obj_Temp.path;
	},

	chooseProgram: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
        		createInstance(nsIFilePicker);
		fp.init(window, this.getSt('jsview.SelectExt'), nsIFilePicker.modeOpen);
		fp.appendFilter(this.getSt('jsview.Programs'),"*.exe");
		fp.appendFilter(this.getSt('jsview.AllFiles'),"*.*");
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = this.getPrefs();
			prefs.setComplexValue('extapp', Components.interfaces.nsILocalFile, fp.file);
			return fp.file;
		} else {
			return false;
		}
	},

	chooseTemp: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
			createInstance(nsIFilePicker);
		fp.init(window, this.getSt('jsview.SelectTmp'), nsIFilePicker.modeGetFolder);
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = this.getPrefs();
			prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, fp.file);
			return fp.file;
		} else {
			return false;
		}
	},

	removeTemp: function() {
		var prefs = this.getPrefs();

		if (prefs.getCharPref('temploc') && prefs.getBoolPref('clearTemp')==true) {
			var obj_Temp = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile);

			var filesArray = [];
			var filesEnum = obj_Temp.directoryEntries;
			while (filesEnum.hasMoreElements()) {
				var file = filesEnum.getNext();
				file.QueryInterface(Components.interfaces.nsIFile);
				filesArray.push(file);
			}

			var i;
			for (i=0; i<filesArray.length; ++i) {
				//var filepath = filesArray[i].path;
				//var fileext = filepath.substr(filepath.lastIndexOf('\.')+1);
				//if (fileext=='js' || fileext=='css') {
					filesArray[i].remove(false);
				//}
			}
		}
	},

	viewOptions: function() {
		window.openDialog('chrome://jsview/content/jsviewOptions.xul',this.getSt('jsview.Options'),'chrome');
	},

	viewAbout: function() {
		window.openDialog('chrome://jsview/content/about.xul',this.getSt('jsview.About'),'chrome');
	}
};

var jsviewListen = {

	EECL: function() {
		jsview.extEditorContext();
	},

	CL: function() {
		jsview.jsviewContext();
	},

	JSCL: function() {
		jsview.jsviewJSContext();
	},

	CSSCL: function() {
		jsview.jsviewCSSContext();
	},

	TL: function() {
		jsview.jsviewToolbar();
	},

	JSTL: function() {
		jsview.jsviewJSToolbar();
	},

	CSSTL: function() {
		jsview.jsviewCSSToolbar();
	},

	BL: function() {
		jsview.jsviewButton();
	},

	SL: function() {
		jsview.jsviewStatus();
	}
};