/***************************************************************************
Name: JSView
Version: 1.1.7
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://scorpiondb.com/firefox/extensions/jsview/
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/





window.addEventListener('load',jsviewPILoad,false);

function jsviewPILoad() {
	jsvPageInfo.retrieveFrames();
	jsvPageInfo.retrieveJS();
	jsvPageInfo.retrieveCSS();
	jsvPageInfo.setEvents();
}


var jsvPageInfo = {

	getMainWin: function() {
		var win = Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");

		if ("document" in top) {
			var nav = top.document.getElementById("main-window");
			if (nav && nav.getAttribute("windowtype") == "navigator:browser") {
				win = top;
			}
		}

		return win;
	},

	getSt: function(name) {
		var win = this.getMainWin();
		var strbdl = win.document.getElementById("jsview-bundle");
		var msg = strbdl.getString(name);
		return msg;
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch('jsview.');
	},

	setEvents: function() {
		var st = document.getElementById('scriptstree');
		var ct = document.getElementById('csstree');
		var ft = document.getElementById('framestree');
		st.ondblclick=jsvPageInfo.isClickOnTreeCell;
		ct.ondblclick=jsvPageInfo.isClickOnTreeCell;
		ft.ondblclick=jsvPageInfo.isClickOnTreeCell;
		document.getElementById('picontext').addEventListener('popupshowing',jsvPageInfo.modifyContext,false);
	},

	findSelectedTree: function(arg) {
		var tab = document.getElementById('tabbox').selectedPanel;
		var tree;

		if (tab.id=='scriptsPanel') {
			tree = document.getElementById('scriptstree');
		} else if (tab.id=='cssPanel') {
			tree = document.getElementById('csstree');
		} else if (tab.id=='framesPanel') {
			tree = document.getElementById('framestree');
		}

		this.cellData(tree,arg);
	},

	modifyContext: function() {
		var i;
		var tab = document.getElementById('tabbox').selectedPanel;
		var vwmenu = document.getElementById('jsview-viewsource');
		var ntbmenu = document.getElementById('jsview-tabblur');
		var ntfmenu = document.getElementById('jsview-tabfocus');
		var eemenu = document.getElementById('jsview-editor');
		var cmenu = document.getElementById('picontext');

		if (tab.id=='scriptsPanel' || tab.id=='cssPanel' || tab.id=='framesPanel') {
			for (i=0; i<cmenu.childNodes.length; ++i) {
				cmenu.childNodes[i].setAttribute('hidden',true);
			}
			vwmenu.setAttribute('hidden',false);
			ntbmenu.setAttribute('hidden',false);
			ntfmenu.setAttribute('hidden',false);
			eemenu.setAttribute('hidden',false);
		} else {
			for (i=0; i<cmenu.childNodes.length; ++i) {
				cmenu.childNodes[i].setAttribute('hidden',false);
			}
			vwmenu.setAttribute('hidden',true);
			ntbmenu.setAttribute('hidden',true);
			ntfmenu.setAttribute('hidden',true);
			eemenu.setAttribute('hidden',true);
		}
	},

	isClickOnTreeCell: function(event) {
		if (event && event.type=='dblclick') {
			var tree = event.currentTarget;
			var row = {}, col = {}, obj = {};
			tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj);
			if (obj.value) jsvPageInfo.cellData(tree,'viewsource');
		}
		return false;
	},

	cellData: function(elem,pref) {
		var data = [];
		var code = "";
		var tree = elem;
		var colname, loc, win, i, filename;

		var win = this.getMainWin();
		var prefs = this.getPrefs();
		var frtab = prefs.getBoolPref('framePref');

		if (tree.id=='scriptstree' || tree.id=='csstree') {
			colname = [tree.columns[0],tree.columns[1],tree.columns[2]];
		} else if (tree.id=='framestree') {
			colname = [tree.columns[0],tree.columns[1]];
		}

		for (i=0; i<colname.length; ++i) {
			data.push(tree.view.getCellText(tree.currentIndex,colname[i]));
		}

		if (tree.id=='framestree' && frtab==true && (pref=='tabblur' || pref=='tabfocus'))
			data[1] = 'view-source:' + data[1];

		if (data[data.length-1]!=this.getSt('jsview.Embedded')) {
			this.showTheCode(data[data.length-1],pref);
		} else {
			if (data[1]!=this.getSt('jsview.NA')) {
				loc = win.content.parent.frames[data[1]];
			} else {
				loc = win.content;
			}

			if (tree.id=='scriptstree') {
				code = loc.document.getElementsByTagName('script')[data[0]].innerHTML;
				filename = '.js';
			} else if (tree.id=='csstree') {
				var rules = loc.document.styleSheets[data[0]].cssRules;
				for (i=0; i<rules.length; ++i) {
					code += rules[i].cssText + '\n';
				}
				filename = '.css';
			}

			if (!code) return false;

			if (code.substr(0,1)=='\n') {
				code = code.replace("\n","");
			}

			var uniqueID = new Date();
			uniqueID = uniqueID.getTime();
			filename = uniqueID.toString() + filename;
			var url = this.writeFile(code,filename);
			if (url!=false) this.showTheCode(url,pref);
		}
		return false;
	},

	showTheCode: function(url,pref) {
		var win = this.getMainWin();

		if (pref=='editor') {
			win.jsview.startProcess(url);
		} else if (pref=='tabblur') {
			win.getBrowser().addTab(url+'?jsview');
		} else if (pref=='tabfocus') {
			var newTab = win.getBrowser().addTab(url+'?jsview');
			win.getBrowser().selectedTab = newTab;
		} else if (pref=='viewsource') {
			win.jsview.viewSourceOfURL(url);
		}
	},

	writeFile: function(sFileContent,name) {
		var obj_Temp;
		var prefs = this.getPrefs();
		var win = this.getMainWin();

		if (!prefs.getCharPref('temploc')) {
			//obj_Temp = this.chooseTemp();
			//if (obj_Temp==false) { return false; }
			//set temp location automatically
			win.jsview.defaultTmpFolder();
		}

		obj_Temp = prefs.getComplexValue('temploc', Components.interfaces.nsILocalFile);

		obj_Temp.append(name);

		try {
			var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
				createInstance(Components.interfaces.nsIFileOutputStream);
			strm.QueryInterface(Components.interfaces.nsIOutputStream);
			strm.QueryInterface(Components.interfaces.nsISeekableStream);
			strm.init(obj_Temp, 0x04 | 0x08, 420, 0);
			strm.write(sFileContent, sFileContent.length);
			strm.flush();
			strm.close();
		} catch(e) {
			alert('The temporary directory cannot be found.\nPlease double check the path and try again.');
			return false;
		}
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].
			createInstance(Components.interfaces.nsIIOService);
		var uri = ioService.newFileURI(obj_Temp);
		return uri.resolve(uri.path);
	},

	chooseTemp: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
			createInstance(nsIFilePicker);
		fp.init(window, this.getSt('jsview.SelectTmp'), nsIFilePicker.modeGetFolder);
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
			var prefs = this.getPrefs();
			prefs.setComplexValue('temploc', Components.interfaces.nsILocalFile, fp.file);
			return fp.file;
		} else {
			return false;
		}
	},

	retrieveFrames: function() {
		var frameSrc, i, item, row, cell;
		var win = this.getMainWin();

		var tree = document.getElementById('frameschild');
		while(tree.firstChild){
			tree.removeChild(tree.firstChild);
		}

		var total = win.content.parent.frames;
		for (i=0; i<total.length; ++i) {
			item = document.createElement('treeitem');
			row = document.createElement('treerow');
			cell = document.createElement('treecell');
			cell.setAttribute('label',i);
			row.appendChild(cell);
			(total[i].document.location.href) ? frameSrc = total[i].document.location.href : frameSrc = this.getSt('jsview.NF');
			cell = document.createElement('treecell');
			cell.setAttribute('label',frameSrc);
			row.appendChild(cell);
			item.appendChild(row);
			tree.appendChild(item);
		}
	},


	retrieveJS: function() {
		var scriptSrc, i, j, item, row, cell, ext;
		var win = this.getMainWin();

		var tree = document.getElementById('scriptschild');
		while(tree.firstChild){
			tree.removeChild(tree.firstChild);
		}

		var total = win.content.document.getElementsByTagName('script');
		for (i=0; i<total.length; ++i) {
			if (total[i].src) {
				ext = total[i].src.substr(total[i].src.lastIndexOf('.'));
				if (ext=='.cgi') continue;
				scriptSrc = total[i].src;
			} else {
				scriptSrc = this.getSt('jsview.Embedded');
			}

			item = document.createElement('treeitem');
			row = document.createElement('treerow');
			cell = document.createElement('treecell');
			cell.setAttribute('label',i);
			row.appendChild(cell);
			cell = document.createElement('treecell');
			cell.setAttribute('label',this.getSt('jsview.NA'));
			row.appendChild(cell);
			cell = document.createElement('treecell');
			cell.setAttribute('label',scriptSrc);
			row.appendChild(cell);
			item.appendChild(row);
			tree.appendChild(item);
		}

		var total = win.content.parent.frames;
		for (j=0; j<total.length; ++j) {
			var scripts = total[j].document.getElementsByTagName('script');
			for (i=0; i<scripts.length; ++i) {
				if (scripts[i].src) {
					ext = scripts[i].src.substr(scripts[i].src.lastIndexOf('.'));
					if (ext=='.cgi') continue;
					scriptSrc = scripts[i].src;
				} else {
					scriptSrc = this.getSt('jsview.Embedded');
				}

				item = document.createElement('treeitem');
				row = document.createElement('treerow');
				cell = document.createElement('treecell');
				cell.setAttribute('label',i);
				row.appendChild(cell);
				cell = document.createElement('treecell');
				cell.setAttribute('label',j);
				row.appendChild(cell);
				(scripts[i].src) ? scriptSrc = scripts[i].src : scriptSrc = this.getSt('jsview.Embedded');
				cell = document.createElement('treecell');
				cell.setAttribute('label',scriptSrc);
				row.appendChild(cell);
				item.appendChild(row);
				tree.appendChild(item);
			}
		}
	},


	retrieveCSS: function() {
		var cssSrc, i, j, loc, item, row, cell;
		var win = this.getMainWin();

		var tree = document.getElementById('csschild');
		while(tree.firstChild){
			tree.removeChild(tree.firstChild);
		}

		loc = win.content.document.location.href;
		var total = win.content.document.styleSheets;
		for (i=0; i<total.length; ++i) {
			item = document.createElement('treeitem');
			row = document.createElement('treerow');
			cell = document.createElement('treecell');
			cell.setAttribute('label',i);
			row.appendChild(cell);
			cell = document.createElement('treecell');
			cell.setAttribute('label',this.getSt('jsview.NA'));
			row.appendChild(cell);
			(total[i].href!=loc) ? cssSrc = total[i].href : cssSrc = this.getSt('jsview.Embedded');
			cell = document.createElement('treecell');
			cell.setAttribute('label',cssSrc);
			row.appendChild(cell);
			item.appendChild(row);
			tree.appendChild(item);

			this.importedCSS(total[i],i,this.getSt('jsview.NA'));
		}

		var total = win.content.parent.frames;
		for (j=0; j<total.length; ++j) {
			loc = total[j].document.location.href;
			var css = total[j].document.styleSheets;
			for (i=0; i<css.length; ++i) {
				item = document.createElement('treeitem');
				row = document.createElement('treerow');
				cell = document.createElement('treecell');
				cell.setAttribute('label',i);
				row.appendChild(cell);
				cell = document.createElement('treecell');
				cell.setAttribute('label',j);
				row.appendChild(cell);
				(css[i].href!=loc) ? cssSrc = css[i].href : cssSrc = this.getSt('jsview.Embedded');
				cell = document.createElement('treecell');
				cell.setAttribute('label',cssSrc);
				row.appendChild(cell);
				item.appendChild(row);
				tree.appendChild(item);

				this.importedCSS(css[i],i,j);
			}
		}
	},

	importedCSS: function(css,i,j) {
		var m, item, row, cell;
		var tree = document.getElementById('csschild');
		var rules = css.cssRules;
		for (m=0; m<rules.length; ++m) {
			if (rules[m].type==3) {
				item = document.createElement('treeitem');
				row = document.createElement('treerow');
				cell = document.createElement('treecell');
				cell.setAttribute('label',i);
				row.appendChild(cell);
				cell = document.createElement('treecell');
				cell.setAttribute('label',j);
				row.appendChild(cell);
				cell = document.createElement('treecell');
				cell.setAttribute('label',rules[m].styleSheet.href);
				row.appendChild(cell);
				item.appendChild(row);
				tree.appendChild(item);

				this.importedCSS(rules[m].styleSheet,i,j);
			} else { break; }
		}
	},

	importCssHelp: function() {
		alert(this.getSt('jsview.ImpCssHlp'));
	}
};

//onLoadRegistry.push(jsvPageInfo.retrieveFrames, jsvPageInfo.retrieveJS, jsvPageInfo.retrieveCSS, jsvPageInfo.setEvents);